# -*- coding: iso-8859-1 -*-
#
# $Id: BaseAnswer.py,v 1.9 2006/01/31 18:17:23 wfenske Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import BaseSchema, Schema, BooleanField, \
     StringField, TextField, SelectionWidget, TextAreaWidget, RichWidget, \
     BaseContent
from Products.Archetypes.Widget import TypesWidget, IntegerWidget, \
     BooleanWidget, StringWidget

from Products.LlsMultipleChoice.config import PROJECTNAME, SKINS_DIR, \
    QUESTION_DIR, QUESTION_TYPES, ANSWER_DIR, \
    ANSWER_TYPES, GLOBALS, PERMISSION_INTERROGATOR, \
    PERMISSION_STUDENT, I18N_DOMAIN
from Products.LlsMultipleChoice.tools import log, hideIdField, \
     registerTypeLogged


from Products.Archetypes.Storage import Storage, ReadOnlyStorage
from Products.CMFCore.utils import getToolByName
import random

class BaseAnswer(BaseContent):
    """ A basic answer. The actual text has to be supplied by the candidate.
    """
    
    # This prevents the Questions from showing up as a portal content type
    global_allow = False

    # See comments in 'AbstractQuestionContainer' for an explanation
    # of the function of a schema, therein defined properties (fields) and 
    # internationalization of the widgets
    localBaseSchema = BaseSchema.copy()
    
    schema = localBaseSchema + Schema((
        StringField(
        name='title',
        required=1,
        searchable=0,
        default='Answer',
        accessor='Title',
        widget=StringWidget(
            label_msgid='label_title',
            visible={'view' : 'invisible',
                     'edit' : 'invisible'},
            i18n_domain='plone',
            ),
        ),
        StringField(
        name='answerkey',
        required=1,
        searchable=0,
        default='',
        accessor='Answerkey',
        mode='r',
        widget=StringWidget(
            label_msgid='label_title',
            visible={'view' : 'visible'},
            i18n_domain=I18N_DOMAIN,
            ),
        ),
        ))

    # Use a custom page template for viewing.
    actions = (
        {
            'id': 'view',
            'action': 'string:${object_url}/baseanswer_view',
            'permissions': (PERMISSION_INTERROGATOR,),
        },
    )
    meta_type = portal_type = archetype_name = 'Base Answer'
    content_icon = 'Answer.png'

    letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

    def Answerkey(self):
        return self.letters[self.contentValues(filter =
                                               {'portal_type':
                                                self.portal_type}).index(self)]
    
    def Title(self):
        return self.archetype_name

# Register this type in Zope
registerTypeLogged(BaseAnswer)
