# -*- coding: iso-8859-1 -*-
#
# $Id: SelectionAnswer.py,v 1.7 2006/01/31 18:17:23 wfenske Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import BaseSchema, Schema, BooleanField, StringField, TextField, SelectionWidget, TextAreaWidget, RichWidget, BaseContent
from Products.Archetypes.Widget import TypesWidget, IntegerWidget, BooleanWidget, StringWidget

from Products.LlsMultipleChoice.config import PROJECTNAME, SKINS_DIR, \
    QUESTION_DIR, QUESTION_TYPES, ANSWER_DIR, \
    ANSWER_TYPES, GLOBALS, PERMISSION_INTERROGATOR, \
    PERMISSION_STUDENT, I18N_DOMAIN
from Products.LlsMultipleChoice.tools import log, registerTypeLogged
from Products.LlsMultipleChoice.AnswerTypes.BaseAnswer import BaseAnswer
from Products.LlsMultipleChoice.InlineTextField import InlineTextField

class SelectionAnswer(BaseAnswer):
    """ A predefined answer that a candidate can select.
    """

    # See comments in 'AbstractQuestionContainer' for an explanation
    # of the function of a schema, therein defined properties (fields) and 
    # internationalization of the widgets
    schema = BaseAnswer.schema + Schema((
            InlineTextField('answer', # See 'description' property of the widget.
                searchable=True,
                required=True,
                primary=True,
                allowable_content_types=('text/plain',
                    'text/structured',
                    'text/restructured',
                    'text/html',),
                default_output_type='text/html',
                widget=TextAreaWidget(
                    label='Answer',
                    label_msgid='answer_label',
                    description='The answer text. This is what the candidate will see.',
                    description_msgid='answer_tool_tip',
                    i18n_domain=I18N_DOMAIN),
                validators=('isXML',),
            ),
        ),
    )
    
    # Use a custom page template for viewing.
    actions = (
        {
            'id': 'view',
            'action': 'string:${object_url}/selectionanswer_view',
            'permissions': (PERMISSION_INTERROGATOR,),
        },
    )
    meta_type = portal_type = archetype_name = 'Selection Answer'
    

# Register this type in Zope
registerTypeLogged(SelectionAnswer)
