# -*- coding: iso-8859-1 -*-
#
# $Id: getCustomQuestionPoints.py,v 1.7 2005/12/01 15:07:01 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

def getCandidatePointsCustom(self, candidateId, givenAnswerIds):
    """This is a sample custom scoring script for type 'MC Question'.
    It gives 1 point for correct answers and subtracts 1 point for
    incorrect answers."""
    if givenAnswerIds is None:
        return 0
    else:
        correctAnswerIds = self.getCorrectAnswerIds(candidateId)
        givenAnswerIds.sort()
        correctAnswerIds.sort()
        if(givenAnswerIds == correctAnswerIds):
            return self.getPoints()
        else:
            penalty = 0
            for correctAnswerId in correctAnswerIds: # correct answers that have or have not been selected
                penalty = penalty + [1, -1][correctAnswerId in givenAnswerIds]
            for givenAnswerId in givenAnswerIds: # wrong answers that have been selected
                if(not (givenAnswerId in correctAnswerIds)):
                    penalty = penalty + 1
            return -penalty
