# -*- coding: iso-8859-1 -*-
#
# $Id: getCustomQuestionPointsProlog.py,v 1.10 2005/12/01 15:07:01 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

def getCandidatePointsCustom(self, candidateId, givenAnswerIds):
  """Sample custom scoring script with guessing correction."""
  minPoints = 0
    try:
        if(givenAnswerIds is None):
            return minPoints
        else:            
            suggestedAnswerIds = getParent(self).getAnswers(candidateId, self.UID())
            correctAnswerIds = self.getCorrectAnswerIds(candidateId)
            
            numCorrectAnswers = len(correctAnswerIds)
            numWrongAnswers = len(suggestedAnswerIds) - numCorrectAnswers
            
            points = self.getPoints() * 1.0
            plus = points / numCorrectAnswers
            minus = - points / numWrongAnswers 
            
            score = 0.0
            for givenAnswerId in givenAnswerIds:
                score = score + [minus, plus][givenAnswerId in correctAnswerIds]
            return max(score, minPoints)
    except:
        return None
