# -*- coding: iso-8859-1 -*-
#
# $Id: Install.py,v 1.12 2005/11/30 16:53:07 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

""" The install script for this Product. I'm not sure how it's 
    supposed to work but at least it's working if this file 
    is called 'Install.py', contains a function 'install(self)' 
    and is located in a directory called 'Extensions'.
"""

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO

from Products.LlsMultipleChoice.config import PROJECTNAME, SKINS_DIR, \
    QUESTION_DIR, QUESTION_TYPES, ANSWER_DIR, \
    ANSWER_TYPES, GLOBALS, PERMISSION_INTERROGATOR, \
    PERMISSION_STUDENT
from Products.LlsMultipleChoice.tools import log

def install(self):
    """ Installs the Product in Plone. """
    out = StringIO()
    try:
        # This will go into the install protocol
        out.write("QUESTION_TYPES = " + unicode(QUESTION_TYPES) + "\n")
        out.write("ANSWER_TYPES = " + unicode(ANSWER_TYPES) + "\n")
        
        # Call Archetypes' install functions
        installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
        install_subskin(self, out, GLOBALS)
        
        #Install the multiple choice tool
        from Products.LlsMultipleChoice.LlsMultipleChoiceTool \
             import LlsMultipleChoiceTool as Tool

        if hasattr(self, Tool.id):
            self.manage_delObjects([Tool.id])
            out.write('Deleting old %s; make sure you repeat customizations.'
                      % Tool.id)
        addTool = self.manage_addProduct[PROJECTNAME].manage_addTool

        addTool(Tool.meta_type)
        # set title of tool:
        tool = getToolByName(self, Tool.id)
        tool.title = Tool.meta_type
        out.write("Added %s to the portal root folder.\n" % tool.title)

        out.write("Successfully installed %s." % PROJECTNAME)
    except Exception, e:
        log("install() failed: " + unicode(e) + "\n")
        out.write("Failed to install %s." % PROJECTNAME)
    return out.getvalue()
