## Script (Python) "deleteEvaluationScript"
##bind container=container
##bind context=context
##bind subpath=traverse_subpath
##parameters=archetype_name=''
##title=
##

#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-
#
# $Id: deleteEvaluationScript.py,v 1.2 2005/12/19 12:17:11 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

""" Handle deletion of custom scoring scripts. """

REQUEST  = container.REQUEST
RESPONSE = REQUEST.RESPONSE

I18N_DOMAIN = 'llsMultipleChoice'

if(not REQUEST.has_key('deleteCustomEvaluationScripts')):
    # i18n is done through llsMultipleChoice-plone-??.po
    msg = context.translate(
        msgid   = 'select_item_delete',
        domain  = I18N_DOMAIN,
        default = 'Please select one or more items to delete first.')
else:
    msg = context.translate(
        msgid   = 'scoring_scripts_deleted',
        domain  = I18N_DOMAIN,
        default = 'Deleted custom scoring scripts for types: ')
    #msg = REQUEST.get('deleteCustomEvaluationScripts')
    deleted = []
    scriptsToBeDeleted = []
    evaluationScripts = context.getEvaluationScripts()

    if same_type(REQUEST['deleteCustomEvaluationScripts'], []):
        scriptsToBeDeleted += REQUEST['deleteCustomEvaluationScripts']
    else:
        scriptsToBeDeleted.append(REQUEST['deleteCustomEvaluationScripts'])
    
    for script in scriptsToBeDeleted:
        if(evaluationScripts.has_key(script)):
            evaluationScripts.pop(script)
            deleted.append(script)
    
    context.setEvaluationScripts(evaluationScripts)

    msg += ", ".join(deleted)
        
target_action = context.getTypeInfo().getActionById('test_import_export')
# Show the success message 'msg' as the portal_status_message.
RESPONSE.redirect(
    '%s/%s?portal_status_message=%s' % ( context.absolute_url(),
                                         target_action,
                                         msg
                                        )
)
