## Script (Python) "exportResults"
##parameters=format='tab'
##title=
##

#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-
#
# $Id: exportResults.py,v 1.8 2005/12/19 12:17:11 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

REQUEST  = context.REQUEST
RESPONSE = REQUEST.RESPONSE

llsmc_tool = context.llsmc_tool

I18N_DOMAIN = 'llsMultipleChoice'

targetAction = context.getTypeInfo().getActionById( 'see_results' )
REDIRECT_URL  = '%s/%s?portal_status_message=' % ( context.absolute_url(),
                                                    targetAction )
if(not REQUEST.has_key('ids')):
    # i18n is done through llsMultipleChoice-plone-??.po
    msg = context.translate(
        msgid   = 'select_item_export',
        domain  = I18N_DOMAIN,
        default = 'Please select one or more items to export first.')
    return RESPONSE.redirect(REDIRECT_URL + msg)

# i18n is done through llsMultipleChoice-plone-??.po
ERROR_FORMAT_MSG = context.translate(
    msgid   = 'unknown_format_export',
    domain  = I18N_DOMAIN,
    default = 'Unknown format. Cannot export.')

if(not format):
    return RESPONSE.redirect(REDIRECT_URL + ERROR_FORMAT_MSG)
format = format.lower()
exportFormatList = filter((lambda (list): list[0].lower() == format), 
    context.RESULTS_EXPORT_FORMATS)
if(not exportFormatList):
    return RESPONSE.redirect(REDIRECT_URL + ERROR_FORMAT_MSG)

exportFormat = exportFormatList[0]
#~ fileExt      = exportFormat[0]
colDelim     = exportFormat[1]
rowDelim     = exportFormat[2]
strStart     = exportFormat[3]
strEnd       = exportFormat[4]
escapeChar   = exportFormat[5]
encoding     = 'latin-1'

def escape(string):
    escaped = ''
    for c in string:
        if(c in [escapeChar, strStart, strEnd]):
            escaped += escapeChar + c
        else:
            escaped += c
    return escaped

results = context.getResultsAsList(REQUEST['ids'])
output = ''
for row in results:
    maxCol = len(row) - 1
    for i in range(0, maxCol+1):
        col = row[i]
        if(same_type(col, '') or same_type(col, u'')):
            # output as text if the content of the cell is a string
            output += strStart + escape(col) + strEnd
        # no string --> no output as text
        elif(same_type(col, 1.1)):
            # i18n of fractional numbers
            output += escape(llsmc_tool.localizeNumber("%.2f", col))
        else:
            output += escape(str(col))
        # append column delimiter or row delimiter 
        # if this is the last column of the row
        output += [colDelim, rowDelim][i >= (maxCol)]


resultsString = context.translate(
    msgid   = 'results',
    domain  = I18N_DOMAIN,
    default = 'results')
    
filename = context.pathQuote(context.title_or_id()) + '_' + resultsString + '.' + format

RESPONSE.setHeader('Content-Disposition', 'attachment; filename=' + filename)
RESPONSE.setHeader('Content-Type', 'text/plain')
# 'unicodeDecode()' is defined in the script (Python)
# Products/LlsMultipleChoice/skins/llsMultipleChoice/unicodeDecode.py
return context.unicodeDecode(output).encode(encoding)
