## Script (Python) "importTest"
##parameters=file=''
##title=
##

#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-
#
# $Id: importTest.py,v 1.8 2005/05/20 10:11:15 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

""" This script will be called when somebody presses 'Import' in the 
    test_import_export.pt form.
"""

REQUEST  = container.REQUEST
RESPONSE = REQUEST.RESPONSE

I18N_DOMAIN = 'llsMultipleChoice'

if (same_type(file, '') or same_type(file, u'')):
    msg = context.translate(\
        msgid   = 'string_not_file',\
        domain  = I18N_DOMAIN,\
        default = 'Got a string, not a file to read.')
else:
    # Call 'MultipleChoiceTest.processQTIImport()"
    addedObjects, errors = context.processQTIImport(file)
    if not errors:
        # The uploaded file seems to be OK.
        msg = context.translate(\
            msgid   = 'file_imported',\
            domain  = I18N_DOMAIN,\
            default = 'The file has been imported.')
    else:
        # The uploaded file has errors.
        msg = context.translate(\
            msgid   = 'errors_occurred',\
            domain  = I18N_DOMAIN,\
            default = 'The following error(s) occurred:') + ' ' \
                + context.str(errors)
    if(addedObjects):
        msg += '\n' + context.translate(\
            msgid   = 'objects_added',\
            domain  = I18N_DOMAIN,\
            default = 'The following objects have been added:') + ' '
        for i in range(0, len(addedObjects)):
            object = addedObjects[i]
            try:
                added = object.title_or_id()
            except:
                added = object
            msg += context.str(added)
            if(i < len(addedObjects) - 1):
                msg += ', '
            else:
                msg += '.'
    else:
        msg += '\n' + context.translate(\
            msgid   = 'nothing_added',\
            domain  = I18N_DOMAIN,\
            default = 'Nothing has been added.')
    msg = msg.replace('\n', ' - ')
    msg = msg.strip()
        
target_action = context.getTypeInfo().getActionById( 'test_import_export' )
# Show the success message 'msg' as the portal_status_message.
RESPONSE.redirect(
    '%s/%s?portal_status_message=%s' % ( context.absolute_url(),
                                         target_action,
                                         msg
                                        )
)
