## Script (Python) "resetResult"
##

#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-
#
# $Id: resetResult.py,v 1.6 2005/05/20 10:11:15 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

""" Deletes the CandidateTestResult instance from the MultipleChoiceTest 
    for the user that pressed the 'Repeat' button in the results/repeat 
    form in test_view.pt.
"""

from AccessControl import getSecurityManager

REQUEST     = context.REQUEST
RESPONSE    = REQUEST.RESPONSE

I18N_DOMAIN = 'llsMultipleChoice'

# Get the user ID of the one calling this script.
submitterId = getSecurityManager().getUser().getId()

# Check if deleting the result is allowed.
if(context.isPublic() and context.hasSubmitted(submitterId) and (context.isAllowRepetition())):
    context.deleteResultOf(submitterId)
    msg = context.translate(\
        msgid   = 'results_reset',\
        domain  = I18N_DOMAIN,\
        default = 'Your results have been reset.')
else:
    # no permission!
    #~ msg = 'You do not have permission to reset your results.'
    from Products.CMFCore.utils import getToolByName
    urlTool = getToolByName(context, 'portal_url')
    portalPath = urlTool.getPortalObject().absolute_url()
    # redirect to 'insufficient_privileges' page
    return RESPONSE.redirect(portalPath + '/insufficient_privileges')
        

targetAction = context.getTypeInfo().getActionById( 'view' )
# Redirect to the view template and display 'msg'.
RESPONSE.redirect(
    '%s/%s?portal_status_message=%s' % ( context.absolute_url(),
                                         targetAction,
                                         msg
                                        ))
